/*
**
Copyright (C) 2002-2007 Novell, Inc. All Rights Reserved. 

THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
TREATIES. USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT
(SDK) THAT CONTAINS THIS WORK. PURSUANT TO THE SDK LICENSE
AGREEMENT, NOVELL HEREBY GRANTS TO DEVELOPER A ROYALTY-FREE,
NON-EXCLUSIVE LICENSE TO INCLUDE NOVELL'S SAMPLE CODE IN ITS
PRODUCT. NOVELL GRANTS DEVELOPER WORLDWIDE DISTRIBUTION RIGHTS TO
MARKET, DISTRIBUTE, OR SELL NOVELL'S SAMPLE CODE AS A COMPONENT OF
DEVELOPER'S PRODUCTS. NOVELL SHALL HAVE NO OBLIGATIONS TO
DEVELOPER OR DEVELOPER'S CUSTOMERS WITH RESPECT TO THIS CODE.
*/

#ifndef ___NMAS_LOGIN_INFO_H___
#define ___NMAS_LOGIN_INFO_H___


/* WARNING:  This header does not support 64-bit development 
*
*  Windows:  _WIN64
*  Sun:      _LP64
*  Linux:    __LP64__  (GNUC)
*  HPUX:     __LP64__ 
*  AIX:      __64BIT__
*/
#if (defined(_WIN64) || defined(_LP64) || defined(__LP64__) || defined (__64BIT__))
#error Header does not support 64-bit development
#endif  


#define NLI_MAX_FIELD_SIZE 256

#define NLI_FIELD_USERNAME	0x00000001
#define NLI_FIELD_CONTEXT	0x00000002
#define NLI_FIELD_TREE		0x00000004
#define NLI_FIELD_SERVER	0x00000008
#define NLI_FIELD_SEQUENCE	0x00000010
#define NLI_FIELD_CLEARANCE	0x00000020

/* New field for the LDAP auth client. If the user ID plug-in has	*/
/* the DN in an LDAP form, it should fill in this field as well	as	*/
/* the username and context fields. The LDAP auth client will check	*/
/* this field first and ignore the username and context fields if	*/
/* this field is valid. The username and context fields should be	*/
/* filled in for Client32 because Client32 will not use this field. */	
#define NLI_FIELD_LDAP_DN	0x00000040

typedef struct NMAS_LOGIN_IDENTITY
{
	int		size;
	int		validFields;
	unicode	userName[NLI_MAX_FIELD_SIZE];
	unicode context[NLI_MAX_FIELD_SIZE];
	unicode tree[NLI_MAX_FIELD_SIZE];
	unicode server[NLI_MAX_FIELD_SIZE];
	unicode sequence[NLI_MAX_FIELD_SIZE];
	unicode clearance[NLI_MAX_FIELD_SIZE];
	unicode ldapDN[NLI_MAX_FIELD_SIZE];
} NMAS_LOGIN_IDENTITY;

/* This is currently implemented in AxNMASCred.ocx. An identity plugin DLL should call this */
/* function when it has retrieved the user ID. */
typedef int (*LPFN_NMAS_SetLoginIdentity)(NMAS_LOGIN_IDENTITY *loginIdentity);

/* An identity plugin DLL must implement these calls */
typedef int (*LPFN_NMAS_StartIdentityPlugin)();
typedef int (*LPFN_NMAS_StopIdentityPlugin)();

/* An identity plugin must implement this API. The OCX will call it passing pointer to its NMAS_SetLoginIdentity */
/* API, and expects to receive pointers to the NMAS_StartIdentityPlugin and NMAS_StopIdentityPlugin APIs in the DLL */
typedef int (*LPFN_NMAS_RegisterIdentityPlugin)(LPFN_NMAS_SetLoginIdentity setIdentity, 
												LPFN_NMAS_StartIdentityPlugin *startIdentityPlugin,
												LPFN_NMAS_StopIdentityPlugin *stopIdentityPlugin);

#endif