# MAKE FILE FOR LINUX for nmas project
###############################################################################
.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) $(CFLAGS)  $<

CC=gcc

METHOD_LIB = lsmcpwdlin.so

COM_SRC = ../../../common/src

UNIX_SRC = ../../src

RPATHS = -Wl,-rpath /usr/lib

VPATH = $(UNIX_SRC):$(COM_SRC)

# These macros contain all the source files. First in the home directory
COMMON_SRCS = cpwdlsm.c

UNIX_SRCS =  unix_lsm.c

C_SRCS = $(COMMON_SRCS) $(UNIX_SRCS)


# These macros contain the include directories.


INCLUDE= -I../../../../../../nmas_server_sdk/sdkinc -I../../../../shared -I/opt/novell/ndk/clib/include 
INC= -I/usr/include -I/usr/include/sys

ifeq "$(DEBUG)" "Y"
	DEBUGFLAGS= -g -DDEBUG
else
	DEBUGFLAGS=
endif

CFLAGS = -c $(DEBUGFLAGS) -fPIC -DPIC  -DUNIX -DLINUX -DNOTRACE -DDS_FOR_UNIX  -DN_PLAT_UNIX -DIAPX386 -DDDS_DYNAMIC $(INCLUDE) \
	$(INC)  -D__BEGIN_CDECLS=  -D__END_CDECLS=  -o $@
	
OBJS = $(C_SRCS:.c=.o)

TARGETS = $(OBJS) $(METHOD_LIB) $(NMASLNK)

defaults: $(TARGETS)

all: $(TARGETS)

$(METHOD_LIB):$(OBJS) 
	$(CC) -shared -Wl,--version-script=../cpwdlin.map $(RPATHS) -o $@ $(OBJS) $(LIBS)


clean:
	rm -f $(TARGETS)

