/*=============================================================================
  CPasswordResourceBundle.java 

  Copyright (c) 1999-2002 Novell, Inc. All Rights Reserved.

  THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE LICENSE AGREEMENT
  ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK) THAT CONTAINS THIS WORK.
  PURSUANT TO THE SDK LICENSE AGREEMENT, NOVELL HEREBY GRANTS TO DEVELOPER A
  ROYALTY-FREE, NON-EXCLUSIVE LICENSE TO INCLUDE NOVELL'S SAMPLE CODE IN ITS
  PRODUCT. NOVELL GRANTS DEVELOPER WORLDWIDE DISTRIBUTION RIGHTS TO MARKET,
  DISTRIBUTE, OR SELL NOVELL'S SAMPLE CODE AS A COMPONENT OF DEVELOPER'S
  PRODUCTS. NOVELL SHALL HAVE NO OBLIGATIONS TO DEVELOPER OR DEVELOPER'S
  CUSTOMERS WITH RESPECT TO THIS CODE.
==============================================================================*/
package com.novell.admin.ndssnapins.loginMethods.CPassword;

import java.util.*;
import java.awt.*;

// Locale specific items for the package com.novell.admin.ndssnapins.classes.nmas
public class CPasswordResourceBundle extends ListResourceBundle
{
	public Object[][] getContents()
	{
		return contents;
	}

	// The list of objects with their corresponding keys is stored here.
	static final private Object[][] contents =
	{
		// TAB names and Snapin Descriptions
		{CPassword.CPassword_METHOD_TAB,					"Login Methods"},
        {CPassword.CPassword_SNAPIN_NAME,					"Manage Cleartext Password Login Method"},
        {CPassword.CPassword_MENU_NAME,						"Cleartext Password"},
        {CPassword.CPassword_METHOD_SNAPIN_DESCRIPTION,		"Cleartext Password Login Method Administration"},
		{CPassword.CPassword_USER_SNAPIN_DESCRIPTION,		"Cleartext Password Login Method User Administration"},
		
		// Message Box Titles and messages
		{CPassword.CPassword_ENTRY_ERR_TITLE,		        "Cleartext Password Entry Error"},
		{CPassword.CPassword_PLC_ERR_MSG,		            "Error from NMASPutLoginSecret: "},
		{CPassword.CPassword_DLC_ERR_MSG,		            "Error from NMASDeleteLoginSecret: "},
		{CPassword.CPassword_UNEQUAL_ERR_MSG,		        "The two cleartext passwords were not equal."},
        {CPassword.CPassword_LOAD_LIBRARY_FAILED_TITLE,   	"API Library Missing"},
        {CPassword.CPassword_LOAD_LIBRARY_FAILED_MESSAGE, 	"The library NMASWrap could not be located."},
        
		// Instructions
		{CPassword.CPassword_INSTRUCTIONS,		        "To enable the cleartext password login method for this user check the enable box and enter a cleartext password. To disable the use of the cleartext password login method by this user uncheck the enable box."},
		
		// Labels
		{CPassword.CPassword_LABEL,		                "Cleartext Password"},
		{CPassword.CPassword_ENTRY_LABEL,		        "Enter Cleartext Password: "},
		{CPassword.CPassword_CONFIRM_LABEL,		        "Confirm Cleartext Password: "},
		{CPassword.CPassword_ALLOW_LABEL,		        "Assign Cleartext Password"},
		{CPassword.CPassword_NOT_SUPPORTED_LABEL,		"Cleartext Password snapin Not Supported"},
		{CPassword.CPassword_NO_RIGHTS_LABEL,		    "Only administrative users may establish or disable the use of the cleartext password method for a user from within ConsoleOne. Non-administrative users who have a cleartext password may change their cleartext password at the time they login with that password."},
	};
}
