#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nmasclnt.h"
#include "nmasconf.h"


int main( int argc, char **argv)
{
   void *hMod  = NULL;
   
   int rc;

   int maj, min, rev, build;
   int methodID = 0;

   NMAS_Info   cInfo;
   NMAS_MethodInfo   mInfo;
   
   rc = NMAS_ClientInfo(&maj, &min, &rev, &build, &cInfo);
   if (0 == rc)
   {
      printf("NMAS_ClientInfo: maj: %d, min: %d, rev: %d, build: %d\n", maj, min, rev, build);
      printf("  version:     %s\n", cInfo.version);
      printf("  build_date:  %s\n", cInfo.build_date);
      printf("  description: %s\n", cInfo.description);
   }
   else
   {
      printf("\nNMAS_ClientInfo error: %d, 0x%08X\n", rc, rc);
      exit(1);
   }

   if (argc > 1)
   {
      methodID = atoi(argv[1]);
      rc = NMAS_ClientMethodInfo(methodID, &mInfo);
      if (0 == rc)
      {
         printf("\n");
         printf("Method Info: \n");
         printf("  methodID:    %d\n", mInfo.methodID);
         printf("  module:      %s\n", mInfo.module);
         printf("  entrypoint:  %s\n", mInfo.entrypoint);
         printf("  vendor:      %s\n", mInfo.vendor);
         printf("  verson:      %s\n", mInfo.version);
         printf("  build_date:  %s\n", mInfo.build_date);
         printf("  description: %s\n", mInfo.description);
         printf("  info_api:    %s\n", mInfo.info_api);
      }
      else
      {
         printf("\nNMAS_ClientInfo error: %d 0x%08X\n", rc, rc);
         exit(1);
      }
   }

   return( 0 );
}

