/************************************************************************
 *
 *  (C) Copyright 2006-2008 Novell, Inc.
 *  All Rights Reserved.
 *
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Novell, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Novell, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/
#ifndef _SASL_MECH_H
#define _SASL_MECH_H

#include <saslapi.h>

SASLAPI int SASLMech_SetSecurityLayerMethod(
    nuint32 nmasHandle,
    nuint32 methodID);

SASLAPI int SASLMech_GetMethodAttribute(
    nuint32 nmasHandle,
    nuint32 methodID,
    unicode *tag,
    size_t *size,
    void *data);

SASLAPI int SASLMech_PutMethodAttribute(
    nuint32 nmasHandle,
    nuint32 methodID,
    unicode *tag,
    size_t size,
    void *data);

SASLAPI int SASLMech_GetAttribute(
    nuint32 nmasHandle,
    nuint32 aid,
    void *uniTag,
    size_t *attributeLenInBytes,
    void *attributeValue);

SASLAPI int SASLMech_PutAttribute(
    nuint32 nmasHandle,
    nuint32 aid,
    void *uniTag,
    size_t attributeLenInBytes,
    void *attributeValue);

SASLAPI int SASLMech_GetLoginReplyBuffer(
    nuint32 nmasHandle,
    nuint32 methodID,
    size_t *outBufferSize,
    char **outBuffer);

SASLAPI int SASLMech_TraceEnabled(
    nuint32 nmasHandle);

SASLAPI int SASLMech_Trace(
    nuint32 nmasHandle,
    char *message);

SASLAPI int SASLMech_TraceEx(
    nuint32 nmasHandle,
    const char *format, 
    ...);

SASLAPI int SASLMech_TraceOnError(
    nuint32 nmasHandle,
    int err,
    char *message);

SASLAPI int SASLMech_LogEvent(
    nuint32 nmasHandle,
    nuint32 methodID,
    nuint32 logLevel,
    nuint32 status,
    unsigned char *statusMsg,   // optional
    nuint32 methodEventID,      // optional
    char *eventMsgFmt, ...);    // optional

#endif

