/************************************************************************
 *
 *  (C) Copyright 2000-2008 Novell, Inc.
 *  All Rights Reserved.
 *
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Novell, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Novell, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *  
 ****************************************************************************/
#ifndef _NMASMSG_H
#define _NMASMSG_H

#include <nmasapi.h>
#include <nmasaddr.h>

#define NMAS_INVALID_NMAS_ID -1 // need to put into a header file

#define NMAS_TRANS_STATUS_CONT                  0x0000
#define NMAS_TRANS_STATUS_SUCCESS               0x0001
#define NMAS_TRANS_STATUS_FAILED                0x0002
#define NMAS_TRANS_STATUS_DONE                  0x0004
#define NMAS_TRANS_STATUS_FIRST                 0x0008
#define NMAS_TRANS_STATUS_DO_LOGIN              0x0010    // Returned by SASL Mechanism to start login
#define NMAS_TRANS_STATUS_DO_INTEG              0x0020    // Indicates that message integrity is supported
#define NMAS_TRANS_STATUS_DO_CONF               0x0040    // Indicates that message privacy is supported
#define NMAS_TRANS_STATUS_PUBLIC_LOGIN          0x0080    // Indicates that the PUBLIC identity should be used

#define NMAS_TRANS_STATUS_LOGIN_SESSION         0x1000    // Indicates Login Session
#define NMAS_TRANS_STATUS_VERIFY_SESSION        0x2000    // Indicates Verify Session
#define NMAS_TRANS_STATUS_AUTHN_SESSION         0x4000    // Indicates Authenticate Session
#define NMAS_TRANS_STATUS_AUTHN_CRED_REFRESH    0x8000    // Indicates Authenticate Creds Refresh Session

#define NMAS_UNKNOWN_SESSION_ID  0xffffffff


NMASAPI int NMAS_MessageHandler(
    nuint32 inSize, char *inBuffer,
    nuint32 *outSize, char **outBuffer,
    nuint32 *nmasID,
    nuint32 *status);

NMASAPI void NMAS_FreeReply(void *buffer);

NMASAPI int NMAS_GetMethodAttribute(
    nuint32 nmasID,
    nuint32 methodID,
    unicode *tag,
    size_t *size,
    void *data);

NMASAPI int NMAS_PutMethodAttribute(
    nuint32 nmasID,
    nuint32 methodID,
    unicode *tag,
    size_t size,
    void *data);

NMASAPI int NMAS_TraceEnabled(
    nuint32 nmasID);

NMASAPI int NMAS_Trace(
    nuint32 nmasID,
    char *message);

NMASAPI int NMAS_TraceOnError(
    nuint32 nmasID,
    int err,
    char *message);

NMASAPI int NMAS_SASLMechLogEvent(
    nuint32 nmasID,
    nuint32 methodID,
    nuint32 logLevel,
    nuint32 status,
    unsigned char *statusMsg,
    nuint32 methodEventID,
    char *methodMsg);

NMASAPI int NMAS_AuditManagementEvent(
    void *handle,
    NMAS_NETADDRESS *clientAddress,
    nuint32 eventID,
    nuint32 logLevel,
    nuint32 status,
    unsigned char *inStatusMsg,
    unicode *subjectDN,
    unicode *targetDN,
    nuint32 methodID,
    unicode *subtarget,
    unicode *otherMsg);

#endif

