/************************************************************************
 *
 *  (C) Copyright 2001-2002 Novell, Inc.
 *  All Rights Reserved.
 *
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Novell, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Novell, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/
#ifndef	_NMASSASL_H
#define	_NMASSASL_H

#include <nmasapi.h>

#define NMAS_INVALID_NMAS_ID -1

#define NMAS_SASL_MECH		1

typedef struct NMASMechanismNames
{
	size_t count;		// number of mechanism names
	char *names[1];		// an array of mechanism names
}NMASMechanismNames;

NMASAPI NMASMechanismNames *NMAS_GetMechanisms(
	nuint32 mechType);

NMASAPI int NMAS_InvokeMechanism(
	nuint32 nmasID,			// NMAS session ID
	nuint32 mechType,		// type of mechanisms to be invoked (i.e., NMAS_SASL_MECH)
	char *mechanism,  		// mechanism name
	char *dn,				// full ldap object DN (optional)
	nuint32 inBufferSize,	// size of mechanism specific data received from client
	void *inBuffer,			// mechanism specific input received from client
	nuint32 *outBufferSize,	// size of mechanism specific data to be sent to client
	void **outBuffer,	  	// mechanism specific data to be sent to client
	nuint32 *status);		// status of SASL Session

#endif
