/************************************************************************
 *
 *  (C) Copyright 2003-2007 Novell, Inc.
 *  All Rights Reserved.
 *
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Novell, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Novell, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/
#ifndef __SPMDCLNT_H
#define __SPMDCLNT_H

#ifdef __cplusplus
# define EXTERNC extern "C"
#else
# define EXTERNC
#endif

#if defined(DS_FOR_NW) || defined(DS_FOR_UNIX) || defined(STATIC_LIBS)
# define SPMCEXPORT
# define SPMCIMPORT
#else
# define SPMCEXPORT __declspec(dllexport)
# define SPMCIMPORT __declspec(dllimport)
#endif

#ifdef __SPMC_SOURCE__
# define SPMC__PORT SPMCEXPORT
#else
# define SPMC__PORT SPMCIMPORT
#endif

#define SPMCAPI EXTERNC SPMC__PORT

#include <nmaspxy.h>
#include <spmconst.h>

// context flags
#define SPM_MOVE_INPUT_CONTEXT		0x1
#define SPM_DONT_DISCOVER_SERVER	0x2

SPMCAPI int SPM_DDCSetPassword(
	int context,
	nuint32 flags,
	char *password);			// NULL terminated UTF-8 string

SPMCAPI int SPM_DDCSetPasswordEx(
	int context,
	nuint32 flags,
	nuint32 passwordType,		// data type of password
	nuint32 passwordSize,		// size in bytes (including NULL termination if any) of password
	void *password,				// password data
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCChangePassword(
	int context,
	nuint32 flags,
	char *oldPassord,			// NULL terminated UTF-8 string
	char *newPassword);			// NULL terminated UTF-8 string

SPMCAPI int SPM_DDCChangePasswordEx(
	int context,
	nuint32 flags,
	nuint32 passwordType,		// data type of passwords
	nuint32 oldPasswordSize,	// size in bytes (including NULL termination if any) of old password
	void *oldPassword,			// old password
	nuint32 newPasswordSize,	// size in bytes (including NULL termination if any) of password
	void *newPassword,			// new password
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCDeletePassword(
	int context,
	nuint32 flags,
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCGetPassword(
	int context,
	nuint32 flags,
	nuint32 passwordType,		// data type of password
	nuint32 *passwordSize,		// size in bytes (including NULL termination if any) of password
	void *password,				// password data
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCGetPasswordRemainingLifetime(
	int  context,
	nuint32 flags,
	nuint32 *infoFlags,
	nuint32 *remainingPwdLife,  // Remaining lifetime of the password
	nuint32 *opFlags);

SPMCAPI int SPM_DDCPasswordPolicyCheck(
	int context,
	nuint32 flags,
	nuint32 passwordType,		// data type of password
	nuint32 passwordSize,		// size in bytes (including NULL termination if any) of password
	void *password,				// password data
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCPutLoginConfig(
	int context,
	nuint32 flags,
	nuint32 methodIDLen,
	nuint32 *methodID,
	unicode *vendorTag,
	nuint32 dataLen,
	void *data,
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCGetLoginConfig(
	int context,
	nuint32 flags,
	nuint32 methodIDLen,
	nuint32 *methodID,
	unicode *vendorTag,
	nuint32 *dataLen,
	void *data,
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags
										
SPMCAPI int SPM_DDCDeleteLoginConfig(
	int context,
	nuint32 flags,
	nuint32 methodIDLen,
	nuint32 *methodID,
	unicode *vendorTag,
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags


SPMCAPI int SPM_DDCPutLoginSecret(
	int context,
	nuint32 flags,
	nuint32 methodIDLen,
	nuint32 *methodID,
	unicode *vendorTag,
	nuint32 dataLen,
	void *data,
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_DDCDeleteLoginSecret(
	int context,
	nuint32 flags,
	nuint32 methodIDLen,
	nuint32 *methodID,
	unicode *vendorTag,
	nuint32 *opFlags);			// operation information flags -- spmconst.h for definition of flags

// login flags
#define SPM_LOCAL_LOGIN_ONLY	    0x1
#define SPM_LOCAL_LOGIN_PREFERRED	0x2
#define SPM_UNLICENSED_LOGIN	    0x4

SPMCAPI int SPM_DDCLogin(
	int  context,
	nuint32 flags,
	DDCNETADDRESS *netaddress,
	nuint32 pwdType,
	nuint32 pwdSize,
	void *password,
	nuint32 *opFlags);

SPMCAPI int SPM_DDCVerifyPassword(
	int  context,
	nuint32 flags,
	nuint32 pwdType,
	nuint32 pwdSize,
	void *password,
	nuint32 *opFlags);

SPMCAPI int SPM_DDCGetPasswordStatus(
	int  context,
	nuint32 flags,
    nuint32 *uPwdStatus,
    nuint32 *sPwdStatus);

SPMCAPI int SPM_DDCCheckLoginPolicy(
	int  context,
    nuint32 flags,
    size_t addressSize,
    nuint8 *address);

SPMCAPI int SPM_DDCAuthNCredsLogin(
	int  context,
	nuint32 flags,
	DDCNETADDRESS *netaddress,
	nuint32 pwdType,
	nuint32 pwdSize,
	void *password,
    nuint32 *authNCredsCnt,
    NMAS_AuthNCred ***authNCreds,
	nuint32 *opFlags);

SPMCAPI int SPM_DDCAuthNCredsUpgrade(
	int  context,
    nuint32 *authNCredsCnt,
    NMAS_AuthNCred ***authNCreds);
    
SPMCAPI int SPM_DDCAuthNCredsRefresh(
	int  context,
    nuint32 oldAuthNCredsCnt,
    NMAS_AuthNCred **oldAuthNCreds,
    nuint32 *newAuthNCredsCnt,
    NMAS_AuthNCred ***newAuthNCreds);
    
SPMCAPI int SPM_DDCAuthenticate(
    int context,
    int options,
    nuint32 oldAuthNCredsCnt,
    NMAS_AuthNCred **oldAuthNCreds,
    nuint32 *newAuthNCredsCnt,
    NMAS_AuthNCred ***newAuthNCreds,
    void **secLayerHandle);

SPMCAPI int SPM_DDCAuthNCredsFree(
	int context,
    nuint32 authNCredsCnt,
    NMAS_AuthNCred **authNCreds);
    
SPMCAPI int SPM_DDCSetAddressPolicy(
	int  context,
    nuint32 flags,
    size_t addressSize,
    nuint8 *address);

SPMCAPI int SPM_DDCGenerateUserRandomPassword(
    int context,
    int flags,
    nuint32 passwordType,
    nuint32 *passwordSize,
    void *password);

#endif

/************************************************************************/
/************************************************************************/
