/************************************************************************
 *
 *  (C) Copyright 2003-2004 Novell, Inc.
 *  All Rights Reserved.
 *
 *  This program is an unpublished copyrighted work which is proprietary
 *  to Novell, Inc. and contains confidential information that is not
 *  to be reproduced or disclosed to any other person or entity without
 *  prior written consent from Novell, Inc. in each and every instance.
 *
 *  WARNING:  Unauthorized reproduction of this program as well as
 *  unauthorized preparation of derivative works based upon the
 *  program or distribution of copies by sale, rental, lease or
 *  lending are violations of federal copyright laws and state trade
 *  secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/
#ifndef __NWDSSPM_H
#define __NWDSSPM_H

#ifdef __cplusplus
# define EXTERNC extern "C"
#else
# define EXTERNC
#endif

#if defined(DS_FOR_NW) || defined(DS_FOR_UNIX)
# define SPMCEXPORT
# define SPMCIMPORT
#else
# define SPMCEXPORT __declspec(dllexport)
# define SPMCIMPORT __declspec(dllimport)
#endif

#ifdef __SPMC_SOURCE__
# define SPMC__PORT SPMCEXPORT
#else
# define SPMC__PORT SPMCIMPORT
#endif

#define SPMCAPI EXTERNC SPMC__PORT

#include <spmconst.h>

SPMCAPI int SPM_NWCCPing(
	NWCONN_HANDLE conn);

SPMCAPI int SPM_NWCCSetObjectPwd(
	NWCONN_HANDLE conn,
	nuint32 entryID,
	pnstr8 pwd);

SPMCAPI int SPM_NWCCSetObjectPwdEx(
	NWCONN_HANDLE conn,
	nuint32 entryID,
	nuint32 flags,			// must be zero
	nuint32 pwdType,		// data type of password
	nuint32 pwdSize,		// size in bytes (including NULL termination if any) of password
	void *pwd,				// password data
	nuint32 *opFlags);		// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_NWCCChangeObjectPwd(
	NWCONN_HANDLE conn,
	nuint32 entryID,
	pnstr8 oldPwd,
	pnstr8 newPwd);

SPMCAPI int SPM_NWCCChangeObjectPwdEx(
	NWCONN_HANDLE conn,
	nuint32 entryID,
	nuint32 flags,			// must be zero
	nuint32 pwdType,		// data type of passwords
	nuint32 oldPwdSize,		// size in bytes (including NULL termination if any) of old password
	void *oldPwd,			// old password
	nuint32 newPwdSize,		// size in bytes (including NULL termination if any) of password
	void *newPwd,			// new password
	nuint32 *opFlags);		// operation information flags -- spmconst.h for definition of flags

SPMCAPI int SPM_NWCCPasswordPolicyCheck(
	NWCONN_HANDLE conn,
	nuint32 entryID,
	nuint32 flags,          // must be zero
	nuint32 pwdType,        // data type of password
	nuint32 passwordSize,   // size in bytes (including NULL termination if any) of password
	void *password,         // password data
	nuint32 *opFlags);      // operation information flags -- spmconst.h for definition of flags
    
SPMCAPI int SPM_NWCCDeleteObjectPwd(
	NWCONN_HANDLE conn,
	nuint32 entryID,
	nuint32 flags,			// must be zero
	nuint32 *opFlags);		// operation information flags -- spmconst.h for definition of flags

typedef struct spm_nwccbuffer
{
    nuint32 size;
    nuint8 *buffer;
}spm_nwccbuffer;

SPMCAPI int SPM_NWCCLogin(
    NWCONN_HANDLE conn,
    unicode *treeName,
    unicode *userDN,
	nuint32 flags,          // must be zero
	nuint32 pwdType,
    nuint32 pwdSize,
	void *password,
    nuint32 *opFlags,       // operation information flags -- spmconst.h for definition of flags
    spm_nwccbuffer *publicKey,
    spm_nwccbuffer *credential,
    spm_nwccbuffer *signature, 
    spm_nwccbuffer *challenge);

SPMCAPI int SPM_NWCCVerifyObjectPwd(
    NWCONN_HANDLE conn,
    unicode *treeName,
    unicode *userDN,
    nuint32 flags,          // must be zero
    nuint32 pwdType,
    nuint32 pwdSize,
    void *password,
    nuint32 *opFlags);      // operation information flags -- spmconst.h for definition of flags;

SPMCAPI int SPM_NWCCVerify(
	pnuint8  NWDS_Challenge,
	pnuint8  SPM_Response);

SPMCAPI int SPM_NWCCGetPassword(
    NWCONN_HANDLE conn,
    nuint32 entryID,
    nuint32 flags,
    nuint32 passwordType,
    nuint32 *passwordSize,
    void *password,
    nuint32 *opFlags);

SPMCAPI int SPM_NWCCGetPasswordRemainingLifetime(
    NWCONN_HANDLE conn,
    nuint32 entryID,
    nuint32 flags,
    nuint32 *infoFlags,
    nuint32 *remainingPwdLife,
    nuint32 *opFlags);

#endif

/************************************************************************/
/************************************************************************/
