/*****************************************************************************

  %name: nmaserr.h %
  %version: idc_nmas#64.1.3 %
  $Copyright:

  Copyright (c) 1999 - 2012 Novell, Inc.  All Rights Reserved.                      

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.$

 ***************************************************************************/


#ifndef _NMASERR_H
#define _NMASERR_H

#define NMAS_E_BASE                       (-1600)

#define NMAS_SUCCESS                      0
#define NMAS_E_SUCCESS                    NMAS_SUCCESS         /* Alias  */
#define NMAS_OK                           NMAS_SUCCESS         /* Alias  */

/* -1600 to -1618 are used by SASDFM, -1619 to -1630 are reserved for it as well */

#define NMAS_E_FRAG_FAILURE               (NMAS_E_BASE-31)     /* -1631 0xFFFFF9A1 */
#define NMAS_E_BAD_REQUEST_SYNTAX         (NMAS_E_BASE-32)     /* -1632 0xFFFFF9A0 */
#define NMAS_E_BUFFER_OVERFLOW            (NMAS_E_BASE-33)     /* -1633 0xFFFFF99F */
#define NMAS_E_SYSTEM_RESOURCES           (NMAS_E_BASE-34)     /* -1634 0xFFFFF99E */
#define NMAS_E_INSUFFICIENT_MEMORY        (NMAS_E_BASE-35)     /* -1635 0xFFFFF99D */
#define NMAS_E_NOT_SUPPORTED              (NMAS_E_BASE-36)     /* -1636 0xFFFFF99C */
#define NMAS_E_BUFFER_UNDERFLOW           (NMAS_E_BASE-37)     /* -1637 0xFFFFF99B */
#define NMAS_E_NOT_FOUND                  (NMAS_E_BASE-38)     /* -1638 0xFFFFF99A */
#define NMAS_E_INVALID_OPERATION          (NMAS_E_BASE-39)     /* -1639 0xFFFFF999 */
#define NMAS_E_ASN1_DECODE                (NMAS_E_BASE-40)     /* -1640 0xFFFFF998 */
#define NMAS_E_ASN1_ENCODE                (NMAS_E_BASE-41)     /* -1641 0xFFFFF997 */
#define NMAS_E_LOGIN_FAILED               (NMAS_E_BASE-42)     /* -1642 0xFFFFF996 */
#define NMAS_E_INVALID_PARAMETER          (NMAS_E_BASE-43)     /* -1643 0xFFFFF995 */
#define NMAS_E_TIMED_OUT_RECOVERABLE      (NMAS_E_BASE-44)     /* -1644 0xFFFFF994 */
#define NMAS_E_TIMED_OUT_NOT_RECOVERABLE  (NMAS_E_BASE-45)     /* -1645 0xFFFFF993 */
#define NMAS_E_TIMED_OUT_UNKNOWN          (NMAS_E_BASE-46)     /* -1646 0xFFFFF992 */
#define NMAS_E_AUTH_FAILURE               (NMAS_E_BASE-47)     /* -1647 0xFFFFF991 */
#define NMAS_E_INVALID_DN                 (NMAS_E_BASE-48)     /* -1648 0xFFFFF990 */
#define NMAS_E_NO_RESOLVE_DN              (NMAS_E_BASE-49)     /* -1649 0xFFFFF98F */
#define NMAS_E_NO_RESOLVE_CONN            (NMAS_E_BASE-50)     /* -1650 0xFFFFF98E */
#define NMAS_E_NO_CRYPTO                  (NMAS_E_BASE-51)     /* -1651 0xFFFFF98D */
#define NMAS_E_INVALID_VERSION            (NMAS_E_BASE-52)     /* -1652 0xFFFFF98C */
#define NMAS_E_SYNC_NEEDED                (NMAS_E_BASE-53)     /* -1653 0xFFFFF98B */
#define NMAS_E_PROTOCOL_STATE             (NMAS_E_BASE-54)     /* -1654 0xFFFFF98A */
#define NMAS_E_INVALID_HANDLE             (NMAS_E_BASE-55)     /* -1655 0xFFFFF989 */
#define NMAS_E_INVALID_METHOD             (NMAS_E_BASE-56)     /* -1656 0xFFFFF988 */
#define NMAS_E_DEVELOPMENT_VERSION        (NMAS_E_BASE-57)     /* -1657 0xFFFFF987 */
#define NMAS_E_MISSING_KEY                (NMAS_E_BASE-58)     /* -1658 0xFFFFF986 */
#define NMAS_E_ACCESS_NOT_ALLOWED         (NMAS_E_BASE-59)     /* -1659 0xFFFFF985 */
#define NMAS_E_SEQUENCE_NOT_FOUND         (NMAS_E_BASE-60)     /* -1660 0xFFFFF984 */
#define NMAS_E_CLEARANCE_NOT_FOUND        (NMAS_E_BASE-61)     /* -1661 0xFFFFF983 */
#define NMAS_E_LSM_NOT_FOUND              (NMAS_E_BASE-62)     /* -1662 0xFFFFF982 */
#define NMAS_E_LCM_NOT_FOUND              (NMAS_E_BASE-63)     /* -1663 0xFFFFF981 */
#define NMAS_E_SERVER_NOT_FOUND           (NMAS_E_BASE-64)     /* -1664 0xFFFFF980 */
#define NMAS_E_LOGIN_ATTRIBUTE_NOT_FOUND  (NMAS_E_BASE-65)     /* -1665 0xFFFFF97F */
#define NMAS_E_LEGACY_INVALID_PASSWORD    (NMAS_E_BASE-66)     /* -1666 0xFFFFF97E */
#define NMAS_E_ACCOUNT_DISABLED           (NMAS_E_BASE-67)     /* -1667 0xFFFFF97D */
#define NMAS_E_ACCOUNT_LOCKED             (NMAS_E_BASE-68)     /* -1668 0xFFFFF97C */
#define NMAS_E_ADDRESS_RESTRICTION        (NMAS_E_BASE-69)     /* -1669 0xFFFFF97B */
#define NMAS_E_CONN_CLEARED               (NMAS_E_BASE-70)     /* -1670 0xFFFFF97A */
#define NMAS_E_TIME_RESTRICTION           (NMAS_E_BASE-71)     /* -1671 0xFFFFF979 */
#define NMAS_E_SHORT_TERM_SECRET          (NMAS_E_BASE-72)     /* -1672 0xFFFFF978 */
#define NMAS_E_NO_NMAS_ON_TREE            (NMAS_E_BASE-73)     /* -1673 0xFFFFF977 */
#define NMAS_E_NO_NMAS_ON_SERVER          (NMAS_E_BASE-74)     /* -1674 0xFFFFF976 */
#define NMAS_E_REQUEST_CHALLENGED         (NMAS_E_BASE-75)     /* -1675 0xFFFFF975 */
#define NMAS_E_LOGIN_CANCELED             (NMAS_E_BASE-76)     /* -1676 0xFFFFF974 */
#define NMAS_E_LOCAL_CRED_STORE           (NMAS_E_BASE-77)     /* -1677 0xFFFFF973 */
#define NMAS_E_REMOTE_CRED_STORE          (NMAS_E_BASE-78)     /* -1678 0xFFFFF972 */
#define NMAS_E_REMOTE_LOGIN_NOT_ALLOWED   (NMAS_E_BASE-79)     /* -1679 0xFFFFF971 */
#define NMAS_E_SEQUENCE_NOT_AUTHORIZED    (NMAS_E_BASE-80)     /* -1680 0xFFFFF970 */
#define NMAS_E_TRANSPORT                  (NMAS_E_BASE-81)     /* -1681 0xFFFFF96F */
#define NMAS_E_CRYPTO_FAILED_INIT         (NMAS_E_BASE-82)     /* -1682 0xFFFFF96E */
#define NMAS_E_DOUBLEBYTE_FAILED_INIT     (NMAS_E_BASE-83)     /* -1683 0xFFFFF96D */
#define NMAS_E_CODEPAGE_FAILED_INIT       (NMAS_E_BASE-84)     /* -1684 0xFFFFF96C */
#define NMAS_E_UNICODE_FAILED_INIT        (NMAS_E_BASE-85)     /* -1685 0xFFFFF96B */
#define NMAS_E_DLL_FAILED_LOADING         (NMAS_E_BASE-86)     /* -1686 0xFFFFF96A */
#define NMAS_E_EVAL_VERSION_WARNING       (NMAS_E_BASE-87)     /* -1687 0xFFFFF969 */
#define NMAS_E_CONCURRENT_LOGIN           (NMAS_E_BASE-88)     /* -1688 0xFFFFF968 */
#define NMAS_E_THREAD_CREATE              (NMAS_E_BASE-89)     /* -1689 0xFFFFF967 */
#define NMAS_E_SECURE_CHANNEL_REQUIRED    (NMAS_E_BASE-90)     /* -1690 0xFFFFF966 */
#define NMAS_E_NO_DEFAULT_USER_SEQUENCE   (NMAS_E_BASE-91)     /* -1691 0xFFFFF965 */
#define NMAS_E_NO_TREENAME                (NMAS_E_BASE-92)     /* -1692 0xFFFFF964 */
#define NMAS_E_MECH_NOT_FOUND             (NMAS_E_BASE-93)     /* -1693 0xFFFFF963 */
#define NMAS_E_ACCOUNT_NOT_ACTIVATED      (NMAS_E_BASE-94)     /* -1694 0xFFFFF962 */
#define NMAS_E_INCOMPATIBLE_LOGIN_DATA    (NMAS_E_BASE-95)     /* -1695 0xFFFFF961 */
#define NMAS_E_PASSWORD_HISTORY_FULL      (NMAS_E_BASE-96)     /* -1696 0xFFFFF960 */
#define NMAS_E_INVALID_SPM_REQUEST        (NMAS_E_BASE-97)     /* -1697 0xFFFFF95F */
#define NMAS_E_PASSWORD_MISMATCH          (NMAS_E_BASE-98)     /* -1698 0xFFFFF95E */
#define NMAS_E_OBSOLETE_METHOD            (NMAS_E_BASE-99)     /* -1699 0xFFFFF95D */

   /* always set MAX to last error code */
#define NMAS_E_BASE_MAX                   NMAS_E_OBSOLETE_METHOD     

                                             
#define NMAS_E_BASE2                         (-16000)

#define NMAS_E_PASSWORD_TOO_LONG             (NMAS_E_BASE2-0)  /* -16000   0xFFFFC180 */
#define NMAS_E_PASSWORD_UPPER_MIN            (NMAS_E_BASE2-1)  /* -16001   0xFFFFC17F */
#define NMAS_E_PASSWORD_UPPER_MAX            (NMAS_E_BASE2-2)  /* -16002   0xFFFFC17E */
#define NMAS_E_PASSWORD_LOWER_MIN            (NMAS_E_BASE2-3)  /* -16003   0xFFFFC17D */
#define NMAS_E_PASSWORD_LOWER_MAX            (NMAS_E_BASE2-4)  /* -16004   0xFFFFC17C */
#define NMAS_E_PASSWORD_NUMERIC_DISALLOWED   (NMAS_E_BASE2-5)  /* -16005   0xFFFFC17B */
#define NMAS_E_PASSWORD_NUMERIC_FIRST        (NMAS_E_BASE2-6)  /* -16006   0xFFFFC17A */
#define NMAS_E_PASSWORD_NUMERIC_LAST         (NMAS_E_BASE2-7)  /* -16007   0xFFFFC179 */
#define NMAS_E_PASSWORD_NUMERIC_MIN          (NMAS_E_BASE2-8)  /* -16008   0xFFFFC178 */
#define NMAS_E_PASSWORD_NUMERIC_MAX          (NMAS_E_BASE2-9)  /* -16009   0xFFFFC177 */
#define NMAS_E_PASSWORD_SPECIAL_DISALLOWED   (NMAS_E_BASE2-10) /* -16010   0xFFFFC176 */
#define NMAS_E_PASSWORD_SPECIAL_FIRST        (NMAS_E_BASE2-11) /* -16011   0xFFFFC175 */
#define NMAS_E_PASSWORD_SPECIAL_LAST         (NMAS_E_BASE2-12) /* -16012   0xFFFFC174 */
#define NMAS_E_PASSWORD_SPECIAL_MIN          (NMAS_E_BASE2-13) /* -16013   0xFFFFC173 */
#define NMAS_E_PASSWORD_SPECIAL_MAX          (NMAS_E_BASE2-14) /* -16014   0xFFFFC172 */
#define NMAS_E_PASSWORD_REPEAT_CHAR_MAX      (NMAS_E_BASE2-15) /* -16015   0xFFFFC171 */
#define NMAS_E_PASSWORD_CONSECUTIVE_MAX      (NMAS_E_BASE2-16) /* -16016   0xFFFFC170 */
#define NMAS_E_PASSWORD_UNIQUE_MIN           (NMAS_E_BASE2-17) /* -16017   0xFFFFC16F */
#define NMAS_E_PASSWORD_LIFE_MIN             (NMAS_E_BASE2-18) /* -16018   0xFFFFC16E */
#define NMAS_E_PASSWORD_EXCLUDE              (NMAS_E_BASE2-19) /* -16019   0xFFFFC16D */
#define NMAS_E_PASSWORD_ATTR_VALUE           (NMAS_E_BASE2-20) /* -16020   0xFFFFC16C */
#define NMAS_E_PASSWORD_EXTENDED_DISALLOWED  (NMAS_E_BASE2-21) /* -16021   0xFFFFC16B */
#define NMAS_E_INVALID_PASSWORD_POLICY       (NMAS_E_BASE2-22) /* -16022   0xFFFFC16A */
#define NMAS_E_LOGIN_FAILED_ERROR_DISPLAYED  (NMAS_E_BASE2-23) /* -16023   0xFFFFC169 */
#define NMAS_E_CFG_METHOD_EXISTS             (NMAS_E_BASE2-24) /* -16024   0xFFFFC168 */
#define NMAS_E_CFG_NO_DATA                   (NMAS_E_BASE2-25) /* -16025   0xFFFFC167 */
#define NMAS_E_CFG_NO_ACCESS                 (NMAS_E_BASE2-26) /* -16026   0xFFFFC166 */
#define NMAS_E_CFG_NO_MORE_ITEMS             (NMAS_E_BASE2-27) /* -16027   0xFFFFC165 */
#define NMAS_E_CFG_METHOD_NOT_FOUND          (NMAS_E_BASE2-28) /* -16028   0xFFFFC164 */
#define NMAS_E_CFG_INVALID_DATA              (NMAS_E_BASE2-29) /* -16029   0xFFFFC163 */
#define NMAS_E_CFG_IDPLUGIN_EXISTS           (NMAS_E_BASE2-30) /* -16030   0xFFFFC162 */
#define NMAS_E_CFG_IDPLUGIN_NOT_FOUND        (NMAS_E_BASE2-31) /* -16031   0xFFFFC161 */
#define NMAS_E_CFG_TRACEINFO_EXISTS          (NMAS_E_BASE2-32) /* -16032   0xFFFFC160 */
#define NMAS_E_CFG_TRACEINFO_NOT_FOUND       (NMAS_E_BASE2-33) /* -16033   0xFFFFC15F */
#define NMAS_E_PASSWORD_UPPER_FIRST          (NMAS_E_BASE2-34) /* -16034   0xFFFFC15E */
#define NMAS_E_PASSWORD_UPPER_LAST           (NMAS_E_BASE2-35) /* -16035   0xFFFFC15D */
#define NMAS_E_PASSWORD_LOWER_FIRST          (NMAS_E_BASE2-36) /* -16036   0xFFFFC15C */
#define NMAS_E_PASSWORD_LOWER_LAST           (NMAS_E_BASE2-37) /* -16037   0xFFFFC15B */
#define NMAS_E_PASSWORD_EXTENDED_FIRST       (NMAS_E_BASE2-38) /* -16038   0xFFFFC15A */
#define NMAS_E_PASSWORD_EXTENDED_LAST        (NMAS_E_BASE2-39) /* -16039   0xFFFFC159 */
#define NMAS_E_PASSWORD_EXTENDED_MIN         (NMAS_E_BASE2-40) /* -16040   0xFFFFC158 */
#define NMAS_E_PASSWORD_EXTENDED_MAX         (NMAS_E_BASE2-41) /* -16041   0xFFFFC157 */
#define NMAS_E_PASSWORD_UPPER_DISALLOWED     (NMAS_E_BASE2-42) /* -16042   0xFFFFC156 */
#define NMAS_E_PASSWORD_LOWER_DISALLOWED     (NMAS_E_BASE2-43) /* -16043   0xFFFFC155 */
#define NMAS_E_USER_CHALLENGES_NOT_SYNCED    (NMAS_E_BASE2-44) /* -16044   0xFFFFC154 */
#define NMAS_E_INVALID_USER_CHALLENGE_SET	 (NMAS_E_BASE2-45) /* -16045   0xFFFFC153 */
#define NMAS_E_CFG_INFO_EXISTS               (NMAS_E_BASE2-46) /* -16046   0xFFFFC152 */
#define NMAS_E_CFG_INFO_NOT_FOUND            (NMAS_E_BASE2-47) /* -16047   0xFFFFC151 */
#define NMAS_E_ENTRY_EXISTS                  (NMAS_E_BASE2-48) /* -16048   0xFFFFC150 */
#define NMAS_E_ENTRY_ATTRIBUTE_NOT_FOUND     (NMAS_E_BASE2-49) /* -16049   0xFFFFC14F */
#define NMAS_E_NO_MORE_ENTRY_ATTRIBUTES      (NMAS_E_BASE2-50) /* -16050   0xFFFFC14E */
#define NMAS_E_UNKNOWN_IDENTITY              (NMAS_E_BASE2-51) /* -16051   0xFFFFC14D */
#define NMAS_E_ENTRY_NOT_FOUND               (NMAS_E_BASE2-52) /* -16052   0xFFFFC14C */
#define NMAS_E_ATTRIBUTE_EXISTS              (NMAS_E_BASE2-53) /* -16053   0xFFFFC14B */
#define NMAS_E_AUDIT_REQUIRED                (NMAS_E_BASE2-54) /* -16054   0xFFFFC14A */
#define NMAS_E_PASSWORD_AD2K8_COMPLEX_VIOLATION    (NMAS_E_BASE2-55) /* -16055   0xFFFFC149 */
#define NMAS_E_PASSWORD_RANDOM_FAILED		   (NMAS_E_BASE2-56) /* -16056   0xFFFFC148 */
#define NMAS_E_PASSWORD_NONALPHA_DISALLOWED  (NMAS_E_BASE2-57) /* -16057   0xFFFFC147 */
#define NMAS_E_PASSWORD_NONALPHA_MIN         (NMAS_E_BASE2- 58)  /* -16058   0xFFFFC146 */
#define NMAS_E_PASSWORD_NONALPHA_MAX         (NMAS_E_BASE2- 59)  /* -16059   0xFFFFC145 */
/* always set MAX to last error code */
#define NMAS_E_BASE2_MAX                     NMAS_E_PASSWORD_NONALPHA_MAX 

#endif


/* ---------------------------------------------------------------------------
 *         !!!! READ THIS --- READ THIS !!!!
 * 
 * When adding new error codes, make appropriate changes to the NMAS Client 
 * messages.rc and msgids.h files.
*/
