/******************************************************************************

  Copyright (c) 2007 Novell, Inc.  All Rights Reserved.                      

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

 *****************************************************************************/
 
#ifndef	_MAFAUTHN_H
#define	_MAFAUTHN_H

#include <nmasapi.h>
#include <nmasaddr.h>
#include <maf.h>

/*Avaiable to Login & Authentication ACM Entrypoints */
int MAF_StoreAuthNCredential(
    MAF_Handle  mh,                    /* (in) MAF Handle provided to the Login & Authentication ACM functions */
    NMAS_GUID   *authNCredGUID,  /* (in) authN credential type */
    size_t       authNCredSize,  /* (in) authN credential size (in bytes) */
    void        *authNCred);     /* (in) authN credential */

int MAF_RetrieveAuthNCredential(
    MAF_Handle  mh,                    /* (in) MAF Handle provided to the Login & Authentication ACM functions */
    NMAS_GUID   *authNCredGUID,  /* (in) authN credential type */
    size_t      *authNCredSize,  /* (in/out) authN credential size (in bytes) */
    void        *authNCred);     /* (out) authN credential */

/*Avaiable to Authentication ACM Entrypoints */
int MAF_StoreSecLayerMaterials(
    MAF_Handle  mh,                    /* (in) MAF Handle provided to the Login & Authentication ACM functions */
    size_t      secLayerMaterialsSize, /* (in) security layer materials size (in bytes) */
    void       *secLayerMaterials);    /* (in) security layer materials */

#endif
	 
