/******************************************************************************
    Copyright (c) 1997-2008 Novell, Inc.  All Rights Reserved.                      

    THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
    TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
    COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
    EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
    WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
    OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
    CRIMINAL AND CIVIL LIABILITY.
 *****************************************************************************/
#ifndef	_MAFHDRS_H
#define	_MAFHDRS_H

/********************************/
// NMAS Message Verbs
/********************************/
#define NMAS_ECHO_VERB                      1
#define NMAS_OPEN_VERB                      3
#define NMAS_VERIFY_VERB                    4
#define NMAS_WRITE_VERB                     5
#define NMAS_READ_VERB                      7
#define NMAS_CLOSE_VERB                     9
#define NMAS_OPEN_AUTHN_VERB                10
#define NMAS_OPEN_AUTHN_CRED_REFRESH_VERB   11

/********************************/
/* PACKET Operations and formats*/
/********************************/

#define MAF_INSTR_FAILURE           0xFF
#define MAF_INSTR_SUCCESS           0x00
#define MAF_INSTR_CAN_DO            0x01	/*	List (...)	*/
#define MAF_INSTR_MORE_CAN_DO       0x02
#define MAF_INSTR_DO                0x03
#define MAF_INSTR_WHAT_NEXT         0x04
#define MAF_INSTR_PROCESS           0x05
#define MAF_INSTR_ACKNOWLEDGE       0x06
#define MAF_INSTR_OEM_SPECIFIC      0x07
#define MAF_INSTR_NACK              0x08
#define MAF_INSTR_AUTHN_CAN_DO      0x09

#define MAF_HEADER_VERSION          0x01

#define MAF_FAILURE_METHOD_ID       0xFFFFFFFF	/*	For use in success and failure messages	*/
#define MAF_SUCCESS_METHOD_ID       0

#define SIZEOF_MAF_V1Header (sizeof(nuint8) + sizeof(nuint8) + sizeof(nuint16) + sizeof(nuint32))

struct MAF_V1Header
{
    nuint8  instr;
    nuint8  ver;    /* 0x01 */
    nuint16 flags;  /* High-low byte order */
    nuint32 length; /* High-low byte order */
};	

/*	OEM ID header structure	*/

// The following wire structure is packed.
typedef struct OEMIDHeader
{
    nuint8  idlen;
    nuint32 OEMID;
    nuint8  padOut[3];
} OEMIDHeader;

// The following macro defines the size of the packed OEMIDHeader structure by adding the
// size of each field i.e., sizeof(idlen) + sizeof(OEMID) + 3*sizeof(padOut[0])  = 8
#define SIZEOF_OEMIDHeader (sizeof(nuint8) + sizeof(nuint32) + 3*sizeof(nuint8))

/*
 * The max size of a packet
*/

#define MAF_MAX_PACKET_LEN		(4*1024)

/*	Defines for tags for short-term secrets used in NMAS verb 6, etc.	*/

#define	ST_SECRETS_ALL_AVAILABLE        (-1)
#define	ST_SECRETS_RETURN_AVAILABLE_IDS (-2)
#define	ST_SECRETS_ATB_NW4_DATA         1
#define	ST_SECRETS_KERBEROS_V5_DATA     2   /* TGT, other tickets, etc. */
#define	ST_SECRETS_NONE                 0

/* Defines for flags in the second tag used in NMAS verb 6 */
#define ST_FLAG_SASDFM      0x1
#define ST_FLAG_PARTKEY     0x2
#define ST_NMAS_ID  		0x4

#endif
	 
