/************************************************************************
 *
  Copyright (c) 2007 Novell, Inc.  All Rights Reserved.                      

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.
 *  
 ****************************************************************************/
#ifndef	_NMASADDR_H
#define	_NMASADDR_H

#include <stddef.h>
#include <ntypes.h>

/* Matches NET_ADDRESS_TYPE in dconst.h. */
typedef enum NMAS_NETADDRESS_TYPE
{
	NMAS_NT_IPX, NMAS_NT_IP, NMAS_NT_SDLC, NMAS_NT_TOKENRING_ETHERNET,
	NMAS_NT_OSI, NMAS_NT_APPLETALK, NMAS_NT_NETBEUI, NMAS_NT_SOCKADDR,
	NMAS_NT_UDP, NMAS_NT_TCP, NMAS_NT_UDP6, NMAS_NT_TCP6, NMAS_NT_INTERNAL,
	NMAS_NT_URL, NMAS_NT_DNS, NMAS_NT_COUNT
} NMAS_NETADDRESS_TYPE;

/* Same as DDCNETADDRESS */
typedef struct NMAS_NETADDRESS
{
	nuint32	type;
	nuint32	length;
	nuint8  data[1];
} NMAS_NETADDRESS;


#define NMAS_MAX_GUID_SIZE 128

typedef nuint8 NMAS_GUID[NMAS_MAX_GUID_SIZE];

#ifdef __cplusplus
extern "C" {
#endif

int Addr_netToPresentation(const NMAS_NETADDRESS *in, char *out, size_t outLen);
int Addr_validateAddressSize(nuint32 type, nuint32 length);
int Addr_validateAddress(const NMAS_NETADDRESS *address);

#ifdef __cplusplus
}
#endif

#endif
	 
