/*
** NMAS Secure Password Manager Password Agent Shim
**
** Copyright (c) 2002-2008 Novell, Inc.  All Rights Reserved.                      
**
** THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
** TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
** COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
** EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
** WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
** OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
** CRIMINAL AND CIVIL LIABILITY.
**
*/
int GetSPMPassword(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
	nuint32 getFlags,
	size_t *passwordLen,
	unicode *password,
	nuint32 *infoFlags,
	nuint32 *remainingLifetime,
	nuint32 *remainingGraceLogins);

int GetSPMPasswordHistory(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
	nuint32 getFlags,
	nuint32 *historyEnabled,
	nuint32 *passwordCount,
	size_t *passwordBufferSize,
	unicode *passwordBuffer);

int SetSPMPassword(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
	size_t passwordLen,
	unicode *password,
	nuint32 setFlags);

int ChangeSPMPassword(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
	size_t oldPasswordLen,
	unicode *oldPassword,
	size_t newPasswordLen,
	unicode *newPassword);

int CheckSPMPasswordPolicy(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
	size_t passwordLen,
	unicode *password);

int GetSPMPasswordStatus(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
    nuint32 *universalPasswordStatus,
    nuint32 *simplePasswordStatus);

int DecryptSPMPasswordInit(
	unicode *agentName,
	unicode *subjDN,
	unicode *treeName,
	unicode *objectDN,
    void **handle);

int DecryptSPMPasswordValue(
    void *handle,
	size_t valueLen,
	void *value,
	size_t *passwordLen,
	unicode *password);

int DecryptSPMPasswordClose(
    void *handle);

int RegisterSPMAgent(
	unicode *agentName);

int DeRegisterSPMAgent(
	unicode *agentName);

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
